<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<script runat="server">
    
    void Page_Load(Object sender, EventArgs e) 
    {
        DataSet ds;
    
        // Attempt to retrieve the dataset
        ds = (DataSet)Cache["Territories"];
    
        // Did we get it
        if(ds == null)
        {
            // Cache the territories
            ds = CacheTerritories();
            // Indicate we did not use the cache
            Message.Text = "Territories loaded from database. " + DateTime.Now;
        }
    
        // Check for the callback
        if(Cache["Callback"] != null)
            Message.Text = (string)Cache["Callback"];
    
        // Bind the data
        lstTerritory.DataSource = ds.Tables[0].DefaultView;
        lstTerritory.DataBind();
    }
    
    public void CacheItemRemoved(string strKey, Object oValue, CacheItemRemovedReason reason)
    {
        Cache["Callback"] = "Recached at " + DateTime.Now;
    
        // Recache the territories
        CacheTerritories();
    }
    
    public DataSet CacheTerritories()
    {
        SqlConnection cn;
        SqlDataAdapter cmd;
        DataSet ds;
    
        // Open a connection
        cn = new SqlConnection("server=localhost;uid=sa;pwd=;database=Northwind");
        // Create an adapter
        cmd = new SqlDataAdapter("select * from territories", cn);
        
        // Fill the dataset
        ds = new DataSet();
        cmd.Fill(ds, "Territories");
        
        // Cache the dataset
        Cache.Insert("Territories", ds, null, Cache.NoAbsoluteExpiration, TimeSpan.FromSeconds(60), CacheItemPriority.Normal, new CacheItemRemovedCallback(this.CacheItemRemoved));
    
        return ds;        
    }
</script>

<html>
    <head>
        <title>Territories Sliding Expiration</title>
    </head>
    <body text="#000000" bgcolor="#ffffff">
        <form id="Territory" runat="server">
            Territory:
            <asp:dropdownlist id="lstTerritory" runat="server" datatextfield="TerritoryDescription" datavaluefield="TerritoryID">
            </asp:dropdownlist>
        </form>
        <asp:label id="Message" runat="server" />
    </body>
</html>
