<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>

<script runat="server">
    void Page_Load(Object sender, EventArgs e)
    {
        DataSet ds;
    
        // Attempt to retrieve the dataset from cache
        ds = (DataSet)Cache["Territories"];
    
        // Did we get it
        if(ds == null)
        {
            SqlConnection cn;
            SqlDataAdapter cmd;
    
            // Open a connection
            cn = new SqlConnection("server=localhost;uid=sa;pwd=;database=Northwind");
            // Create an adapter
            cmd = new SqlDataAdapter("select * from territories", cn);
    
            // Fill the dataset
            ds = new DataSet();
            cmd.Fill(ds, "Territories");
    
            // Cache the dataset
            Cache.Insert("Territories", ds, null, Cache.NoAbsoluteExpiration, TimeSpan.FromSeconds(60));
    
            // Indicate we didn't use the cache
            Message.Text = "Territories loaded from database." + DateTime.Now;
        }
    
        // Bind the data
        lstTerritory.DataSource = ds.Tables[0].DefaultView;
        lstTerritory.DataBind();
    }
</script>

<html>
    <head>
        <title>Territories Sliding Expiration</title>
    </head>
    <body text="#000000" bgcolor="#ffffff">
        <form id="Territory" runat="server">
            Territory:
            <asp:dropdownlist id="lstTerritory" runat="server" datatextfield="TerritoryDescription" datavaluefield="TerritoryID">
            </asp:dropdownlist>
        </form>
        <asp:label id="Message" runat="server" />
    </body>
</html>

