<%@ Page Language="C#" %>

<script runat="server">
   void ListCache()
   {
      StringBuilder sbOutput;
      string szType;

      // Show the number of items in the cache
     sbOutput = new StringBuilder("Items in Cache = " + Cache.Count.ToString() + "<Br>");

     // Start the table
     sbOutput.Append("<table border=1><tr><th>Key</th><th>Data Type</th></tr>");

     // Clear the list
     lstCache.Items.Clear();

     // Loop through the cache
     foreach(System.Collections.DictionaryEntry oItem in Cache)
         {
         // Add To List
         lstCache.Items.Add(oItem.Key.ToString());
         // Have to watch for a null object during expiration
         if(Cache[oItem.Key.ToString()] == null)
             szType = "Nothing";
         else
             szType = Cache[oItem.Key.ToString()].GetType().ToString();

         // Add to table
         sbOutput.Append("<tr><td>" + oItem.Key + "</td><td>" + szType + "</td></tr>");
         }

     // Close the table
     sbOutput.Append("</table>");

     // Place in page
     tblCache.InnerHtml = sbOutput.ToString();     
   }
      
   void Page_Load(Object sender, EventArgs e)
   {
      // Only run it if no other event is happening
      if(!IsPostBack)
         ListCache();
   }
   
   void btnRemove_Click(Object sender, EventArgs e)
   {
      // Remove the item
      Cache.Remove(lstCache.SelectedItem.Text);
      // Re list the cache
      ListCache();
   }
   
   void btnAdd_Click(Object sender, EventArgs e)
   {
      CacheItemPriority p = CacheItemPriority.NotRemovable;

      switch(ddPriority.SelectedItem.Text)
      {
         case "High":
            p = CacheItemPriority.High;
            break;
         case "Above Normal":
            p = CacheItemPriority.AboveNormal;
            break;
         case "Normal":
             p = CacheItemPriority.Normal;
             break;
         case "Below Normal":
             p = CacheItemPriority.BelowNormal;
             break;
         case "Low":
             p = CacheItemPriority.Low;
             break;
         case "Not Removable":
             p = CacheItemPriority.NotRemovable;
             break;
      }
      
      
      if(txtSliding.Text != "")
         {
         // Save the value with a sliding expiration
         Cache.Insert(txtKey.Text, txtValue.Text, null, Cache.NoAbsoluteExpiration, TimeSpan.FromSeconds(Double.Parse(txtSliding.Text)), p, null);
         }
      else
         if(txtAbsolute.Text != "")
            {
            // Save the value with an absolute expiration
            Cache.Insert(txtKey.Text, txtValue.Text, null, DateTime.Now.AddSeconds(Double.Parse(txtAbsolute.Text)), Cache.NoSlidingExpiration, p, null);
            }
         else      
            {
            // Save the value
            Cache.Insert(txtKey.Text, ((object)txtValue.Text), null, DateTime.MinValue, TimeSpan.Zero, p, null);
            }

      // List out the cache
      ListCache();
   }
   
</script>

<html>
<head>
<title>Working with the Cache</title>
</head>

<body bgcolor="#FFFFFF" text="#000000">
    <form id="CacheWork" runat=server>
        <table>
            <tr>
                <td>Key:</td>
                <td><asp:textbox id="txtKey" runat=server /></td>
                <td>Value: </td>
                <td><asp:textbox id="txtValue" runat=server /></td>
                <td><asp:button id="btnAdd" Text="Add" runat=server  
                  OnClick="btnAdd_Click" /></td>
            </tr>
            <tr>
                <td>Absolute:</td>
                <td><asp:textbox id="txtAbsolute" runat=server /></td>
                <td>Sliding:</td>
                <td><asp:textbox id="txtSliding" runat=server /></td>
                <td>&nbsp;</td>
            </tr>
            <tr>
                <td>Priority:</td>
                <td><asp:dropdownlist id="ddPriority" runat=server>
                        <asp:listitem>High</asp:listitem>
                        <asp:listitem>Above Normal</asp:listitem>
                        <asp:listitem Selected="true">Normal</asp:listitem>
                        <asp:listitem>Below Normal</asp:listitem>
                        <asp:listitem>Low</asp:listitem>
                        <asp:listitem>Not Removable</asp:listitem>
                    </asp:dropdownlist></td>
                <td colspan=3>&nbsp;</td>
            </tr>
        </table>
        <hr>
            <asp:listbox id="lstCache" runat=server />
            <asp:button id="btnRemove" Text="Remove" runat=server 
               OnClick="btnRemove_Click" />
    </form>
    <hr>
    <span id="tblCache" runat=server></span>
</body>
</html>

