using System;
using System.Collections;
using System.ComponentModel;
using System.Web;
using System.Web.SessionState;

namespace DBFormURL 
{
	/// <summary>
	/// Summary description for Global.
	/// </summary>
	public class Global : System.Web.HttpApplication
	{
		protected void Application_Start(Object sender, EventArgs e)
		{
			Application["DSN"] = "SERVER=localhost;UID=sa;PWD=;DATABASE=SecuritySample";
		}

		protected void Application_AuthenticateRequest(object sender, EventArgs e)
		{
			// Make sure the user has been authenticated
			// This event fires for unauthenticated users also
			if(Request.IsAuthenticated)
			{
				// Get the users identity 
				System.Web.Security.FormsIdentity fiUser  = (System.Web.Security.FormsIdentity)User.Identity;
				// Get the ticket
				System.Web.Security.FormsAuthenticationTicket at = fiUser.Ticket;
				// Grab out the roles
				string strRoles = at.UserData;
				// Renew the ticket if need be
				System.Web.Security.FormsAuthenticationTicket ticket = System.Web.Security.FormsAuthentication.RenewTicketIfOld(at);
				if(ticket!=at)
				{
					// Get the encrypted version of the ticket
					string strEncrypted = System.Web.Security.FormsAuthentication.Encrypt(ticket);

					// Put it into a cookie
					HttpCookie hc = new HttpCookie(System.Web.Security.FormsAuthentication.FormsCookieName, strEncrypted);
					hc.Expires = DateTime.Now.AddMinutes(20);


					// Add it to the cookies collection
					Response.Cookies.Add(hc);
				}

				// Create a new principal which includes our role information from the cookie
				HttpContext.Current.User = new System.Security.Principal.GenericPrincipal(fiUser, strRoles.Split(','));
			}
		}
	}
}

