using System;
using System.Web;
using System.Web.UI;

namespace Handlers
{
	/// <summary>
	/// Summary description for HandlerFactory.
	/// </summary>
	public class HandlerFactory : IHttpHandlerFactory
	{
		public IHttpHandler GetHandler(HttpContext context, string requestType, string url, string pathTranslated)
		{

			// Check the name property 
			if(context.Request["Name"] == "Chris")
				// If it's Chris return chris
				return new ChrisHandler();
			else
				// Else return Jeff
				return new JeffHandler();
		}

		// required to implement the interface
		public void ReleaseHandler(IHttpHandler handler) 
		{
		}
	}

	/// The ChrisHandler
	/// 
	public class ChrisHandler : IHttpHandler
	{
		public void ProcessRequest(HttpContext context)
		{
			context.Response.Write("<html><body>Chris</body></html>");
		}

		public bool IsReusable
		{
			get
			{
				return true;
			}
		}
	
	}

	/// The JeffHandler
	/// 
	public class JeffHandler : IHttpHandler
	{
		public void ProcessRequest(HttpContext context)
		{
			context.Response.Write("<html><body>Jeff</body></html>");
		}

		public bool IsReusable
		{
			get
			{
				return true;
			}
		}

	}

}
