using System;
using System.Drawing;

namespace SimpleHandler
{
	/// <summary>
	/// Summary description for PageCounter.
	/// </summary>
	public class PageCounter : System.Web.IHttpHandler
	{
		// object to hold our counters
		private System.Collections.Hashtable hPageCounter = new System.Collections.Hashtable();

		public PageCounter()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public void ProcessRequest(System.Web.HttpContext context)
		{
			int iPageCount = 1;
			string strUrl = context.Request.UrlReferrer.ToString();
			string strPageCount;

			if(hPageCounter.Contains(strUrl))
			{
				// Get the page count and increment by 1
				iPageCount = (int) hPageCounter[strUrl] + 1;
				// Create a string of the page count
				strPageCount= iPageCount.ToString();
				// Update the page count
				hPageCounter[strUrl] = iPageCount;
			}
			else
			{
				// Init the page count
				hPageCounter.Add(strUrl, 1);
				// Set the page count to 1
				strPageCount = iPageCount.ToString();
			}

			// Create a new bitmap of minimum size
			Bitmap b = new Bitmap(1,1);
			// Get a graphics surface
			Graphics g = Graphics.FromImage(b);
			// Create a font
			Font f = new Font("Verdana", 14);

			// Measure the string so we know how wide to make it
			SizeF s = g.MeasureString(strPageCount, f);

			// Create the proper size bitmap
			b = new Bitmap((int)s.Width, (int)s.Height);
			// Get the grpahics surface again
			g = Graphics.FromImage(b);
			// Clear the background to white
			g.Clear(System.Drawing.Color.White);
			// Indicate antialiased text
			g.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;

			// Draw the page count on the bitmap
			g.DrawString(strPageCount, f, new SolidBrush(System.Drawing.Color.Black), 0, 0);
			g.Flush();

			// Output the graphic
			context.Response.ContentType = "image/gif";
			b.Save(context.Response.OutputStream, System.Drawing.Imaging.ImageFormat.Gif);
		}

		public bool IsReusable
		{
			get
			{
				return true;
			}
		}
	}
}
