using System;
using System.Data.SqlClient;

namespace Handlers
{
	/// <summary>
	/// Summary description for SqlHandler.
	/// </summary>
	public class SqlHandler : System.Web.IHttpHandler
	{
		public SqlHandler()
		{
		}

		// Call like this
		// http://localhost/book/handlemod/csharp/handlers/tableviewer.xsql?sql=select%20*%20from%20authors%20for%20xml%20auto,%20elements
		public void ProcessRequest(System.Web.HttpContext context)
		{
			System.IO.FileStream fs = null;
			SqlConnection cn = null;

			try
			{	
				// Get the sql
				string strSql = context.Request["SQL"];

				// Setup a DB connection
				cn = new SqlConnection("SERVER=localhost;UID=sa;PWD=;DATABASE=pubs;");
				// Open the connection
				cn.Open();
				// Create a command
				SqlCommand cmd = new SqlCommand(strSql, cn);
				// Get a data reader reference
				SqlDataReader dr;
				// Execute the sql
				dr = cmd.ExecuteReader();
				
				// Get a buffer
				System.Text.StringBuilder strBuff = new System.Text.StringBuilder("<?xml version=\"1.0\" encoding=\"utf-8\" ?>\r\n");
				// Encapsulate with root element
				strBuff.Append("<results>");
				// Get all the rows
				while(dr.Read())
				{
					strBuff.Append(dr.GetString(0));
				}
				// Add the ending element
				strBuff.Append("</results>\r\n");
				// Close the connection
				cn.Close();
				// Load XML into document
				System.Xml.XmlDocument xd = new System.Xml.XmlDocument();
				// Load it up
				xd.LoadXml(strBuff.ToString());
				
				// Attempt to open the xslt
				fs = new System.IO.FileStream(context.Request.PhysicalPath, System.IO.FileMode.Open);
				// Load it into a navigator
				System.Xml.XPath.XPathDocument xpn = new System.Xml.XPath.XPathDocument(new System.Xml.XmlTextReader(fs));
				
				// Close the file
				fs.Close();

				// Create a transform
				System.Xml.Xsl.XslTransform xslt = new System.Xml.Xsl.XslTransform();
				// Load it
				xslt.Load(xpn);

				// Transform it to the output stream
				xslt.Transform(xd.CreateNavigator(), null, context.Response.Output);


			}
			catch(Exception e)
			{
				// Write an error message
				context.Response.Write("<body><html>Invalid xsql query<Br>Message: " + e.Message + "</html></body>");
			}
			finally
			{
				// Close the file stream
				if(fs!=null) fs.Close();	
				// Close the db connection
				if(cn!=null) cn.Close();
			}

		}

		public bool IsReusable
		{
			get
			{
				return true;
			}
		}

	}
}
