using System;
using System.Web.Security;

namespace SimpleModule
{
	/// <summary>
	/// Summary description for AuthModule.
	/// </summary>
	public class AuthModule : System.Web.IHttpModule
	{
		private System.Web.HttpApplication mApplication;

		public AuthModule()
		{
		}

		public void Init(System.Web.HttpApplication application)
		{
			// Wire up beginrequest
			application.AuthenticateRequest += new System.EventHandler(AuthenticateRequest);
			// Save the application
			mApplication = application;
		}

		public void AuthenticateRequest(object sender, EventArgs e)
		{
			// Make sure that the user has already authenticated
			// This event fires for unauthenticated users also
			if(mApplication.Context.Request.IsAuthenticated)
			{
				// Get the users identity
				FormsIdentity fiUser = (System.Web.Security.FormsIdentity) mApplication.Context.User.Identity;
				// Get the ticket
				FormsAuthenticationTicket at = fiUser.Ticket;
				// Grab out the roles
				string astrRoles = at.UserData;
				// Renew the ticket if need be
				FormsAuthentication.RenewTicketIfOld(at);

				// Create a new principal which includes our role information from the cookie
				mApplication.Context.User = new System.Security.Principal.GenericPrincipal(fiUser, astrRoles.Split(','));
			}
		}

		public void Dispose()
		{
		}
	}
}
