using System;
using System.Web;
using System.Diagnostics;

namespace SimpleModules
{
	/// <summary>
	/// Summary description for ErrorModule.
	/// <add type="SimpleModules.ErrorModule, SimpleModules" name="ErrorModule" />
	/// </summary>
	public class ErrorModule : IHttpModule
	{
		private const string strEVENTLOGNAME = "ASP.NET ErrorModule";

		private HttpApplication mApplication;

		public void Init(HttpApplication application)
		{
			// Save off the application
			mApplication = application;

			// Wire up the error handler
			mApplication.Error += new System.EventHandler(this.ErrorHandler);
		}

		private void ErrorHandler(object sender, EventArgs e)
		{
			// Create the event source if it doesn't exist
			if(!EventLog.SourceExists(strEVENTLOGNAME))
				EventLog.CreateEventSource(strEVENTLOGNAME, strEVENTLOGNAME + " Log");

			// Create an event log instance and point it at the event source
			EventLog el = new EventLog();
			el.Source = strEVENTLOGNAME;

			// Create the error text
			string strErrorMessage = "An uncaught exception was thrown in your application\r\nUrl: " + mApplication.Request.Url.ToString() + "\r\nMessage:" + mApplication.Context.Error.Message + "\r\nStack Trace:" + mApplication.Context.Error.StackTrace;

			// Write the event log entry
			el.WriteEntry(strErrorMessage, EventLogEntryType.Error);

			// Mail the message to the web master
			System.Web.Mail.SmtpMail.Send("webserver@vergentsoftware.com", "ckinsman@vergentsoftware.com", "Web Site Error", strErrorMessage);
		}

		public void Dispose()
		{
		}
	}
}
