using System;
using System.Web;

namespace SimpleModules
{
	/// <summary>
	/// Summary description for EventRaise.
	/// <add type="SimpleModules.EventRaise, SimpleModules" name="EventRaise" />
	/// </summary>
	public class EventRaise : IHttpModule
	{
		private HttpApplication mApplication;

		public event EventHandler MyEvent;

		public void Init(HttpApplication application)
		{
			// Save off the application object
			mApplication = application;

			// Wire up begin request
			mApplication.BeginRequest += new System.EventHandler(this.BeginRequest);
		}

		private void BeginRequest(object sender, EventArgs e)
		{
			OnMyEvent(new EventArgs());
		}

		private void OnMyEvent(EventArgs e)
		{
			if(MyEvent!=null)
				MyEvent(this, e);
		}

		public void Dispose()
		{
		}
	}
}
